#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include "Server.h"

Server server;

void interruptHandler(int signal)
{
    serverRemove(&server);
    exit(EXIT_SUCCESS);
}

void test(Stream* in)
{
    int i;
    while(streamGetInt(&i, in) != -1)
    {
        printf("%d  ", i);
    }
    printf(" HALLO\n");
}

void test2(Stream* in)
{
    printf("HALLO2\n");
}

void test3(Stream* in)
{
    printf("HALLO3\n");
}

int main()
{
    serverInitDefaults(&server);
    
    signal(SIGINT, interruptHandler);
    signal(SIGKILL, interruptHandler);
    
    if(serverInit(&server, 3, 6543))
    {
        return EXIT_FAILURE;
    }
    
    serverRegisterHandler(&server, test);
    serverRegisterHandler(&server, test2);
    serverRegisterHandler(&server, test3);
    
    serverWaitForConnection(&server);
    
    serverRemove(&server);
    return EXIT_SUCCESS;
}
